/**
   @Author:
      Date: 
   Teacher:
       Lab:
      Misc:
  */

import java.awt.Color;

public class DarterFish extends Fish
{
    public DarterFish(Environment env, Location loc)
    {
        // Construct and initialize the attributes inherited from Fish.
        super(env, loc, env.randomDirection(), Color.yellow);
    }

    public DarterFish(Environment env, Location loc, Direction dir)
    {
        // Construct and initialize the attributes inherited from Fish.
        super(env, loc, dir, Color.yellow);
    }
        
    public DarterFish(Environment env, Location loc, Direction dir, Color col)
    {
        // Construct and initialize the attributes inherited from Fish.
        super(env, loc, dir, col);
    }

    protected void generateChild(Location loc)
    {
        // Create new fish, which adds itself to the environment.
        DarterFish child = new DarterFish(environment(), loc,
                                          environment().randomDirection(),
                                          color());
        Debug.println("  New DarterFish created: " + child.toString());
    }

    protected void move()
    {
        // Find a location to move to.
        Debug.print("DarterFish " + toString() + " attempting to move.  ");
        Location nextLoc = nextLocation();

        // If the next location is different, move there.
        if ( ! nextLoc.equals(location()) )
        {
            changeLocation(nextLoc);
            Debug.println("  Moves to " + location());
        }
        else
        {
            // Otherwise, reverse direction.
            changeDirection(direction().reverse());
            Debug.println("  Now facing " + direction());
        }
    }

    protected Location nextLocation()
    {
        Environment env = environment();
        Location oneInFront = env.getNeighbor(location(), direction());
        Location twoInFront = env.getNeighbor(oneInFront, direction());
        Debug.println("  Location in front is empty? " + 
                        env.isEmpty(oneInFront));
        Debug.println("  Location in front of that is empty? " + 
                        env.isEmpty(twoInFront));
        if ( env.isEmpty(oneInFront) )
        {
            if ( env.isEmpty(twoInFront) )
                return twoInFront;
            else
                return oneInFront;
        }

        // Only get here if there isn't a valid location to move to.
        Debug.println("  Darter is blocked.");
        return location();
    }
}
